package cz.jzitnik.game;

import cz.jzitnik.game.sprites.*;
import cz.jzitnik.game.sprites.SimpleSprite;
import cz.jzitnik.tui.Sprite;
import cz.jzitnik.tui.SpriteList;

import java.util.HashMap;

public class SpriteLoader {
    public enum SPRITES {
        AIR,
        DIRT,
        GRASS,
        STEVE,
        STONE,
        BEDROCK,
        BREAKING,
        COBBLESTONE,
        FURNACE,
        WOOL,

        CHEST,
        CRAFTING_TABLE,
        COAL_ORE,

        OAK_LOG,
        OAK_LEAF,
        OAK_PLANKS,
        OAK_DOOR,

        WOODEN_PICKAXE,
        STONE_PICKAXE,
        WOODEN_AXE,
        STONE_AXE,
        WOODEN_SHOVEL,
        STONE_SHOVEL,

        // Items
        ITEM_DIRT,
        ITEM_OAK_LOG,
        ITEM_OAK_PLANKS,
        ITEM_STICK,
        ITEM_COBBLESTONE,
        ITEM_STONE,
        ITEM_FURNACE,
        ITEM_OAK_DOOR,
        ITEM_WOOL,

        ITEM_CRAFTING_TABLE,
        ITEM_CHEST,

        HEART,
        HUNGER,

        PIG,
        SHEEP,

        ITEM_PORKCHOP,
        ITEM_COOKED_PORKCHOP,

        ITEM_MUTTON,
        ITEM_COOKED_MUTTON,
    }

    public static final HashMap<SPRITES, Sprite> SPRITES_MAP = new HashMap<>();

    static {
        SPRITES_MAP.put(SPRITES.AIR, new Air());
        SPRITES_MAP.put(SPRITES.DIRT, new SimpleSprite("dirt.ans"));
        SPRITES_MAP.put(SPRITES.GRASS, new SimpleSprite("grass.ans"));
        SPRITES_MAP.put(SPRITES.STONE, new SimpleSprite("stone.ans"));
        SPRITES_MAP.put(SPRITES.STEVE, new Steve());
        SPRITES_MAP.put(SPRITES.BEDROCK, new SimpleSprite("bedrock.ans"));
        SPRITES_MAP.put(SPRITES.BREAKING, new Breaking());
        SPRITES_MAP.put(SPRITES.OAK_LOG, new SimpleSprite("oak_log.ans"));
        SPRITES_MAP.put(SPRITES.OAK_LEAF, new SimpleSprite("oak_leaf.ans"));
        SPRITES_MAP.put(SPRITES.OAK_PLANKS, new SimpleSprite("oak_planks.ans"));
        SPRITES_MAP.put(SPRITES.CRAFTING_TABLE, new SimpleSprite("crafting_table.ans"));
        SPRITES_MAP.put(SPRITES.CHEST, new SimpleSprite("chest.ans"));
        SPRITES_MAP.put(SPRITES.COBBLESTONE, new SimpleSprite("cobblestone.ans"));
        SPRITES_MAP.put(SPRITES.FURNACE, new Furnace());
        SPRITES_MAP.put(SPRITES.COAL_ORE, new SimpleSprite("coal_ore.ans"));
        SPRITES_MAP.put(SPRITES.OAK_DOOR, new OakDoor());
        SPRITES_MAP.put(SPRITES.WOOL, new Wool());

        SPRITES_MAP.put(SPRITES.WOODEN_PICKAXE, new SimpleSprite("items/wooden_pickaxe.ans"));
        SPRITES_MAP.put(SPRITES.STONE_PICKAXE, new SimpleSprite("items/stone_pickaxe.ans"));
        SPRITES_MAP.put(SPRITES.WOODEN_AXE, new SimpleSprite("items/wooden_axe.ans"));
        SPRITES_MAP.put(SPRITES.STONE_AXE, new SimpleSprite("items/stone_axe.ans"));
        SPRITES_MAP.put(SPRITES.WOODEN_SHOVEL, new SimpleSprite("items/wooden_shovel.ans"));
        SPRITES_MAP.put(SPRITES.STONE_SHOVEL, new SimpleSprite("items/stone_shovel.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_DIRT, new SimpleSprite("items/dirt.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_OAK_LOG, new SimpleSprite("items/oak_log.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_OAK_PLANKS, new SimpleSprite("items/oak_planks.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_STICK, new SimpleSprite("items/stick.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_CRAFTING_TABLE, new SimpleSprite("items/crafting_table.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_COBBLESTONE, new SimpleSprite("items/cobblestone.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_STONE, new SimpleSprite("items/stone.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_CHEST, new SimpleSprite("items/chest.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_FURNACE, new SimpleSprite("items/furnace.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_OAK_DOOR, new SimpleSprite("oak_door/items/oak_door.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_PORKCHOP, new SimpleSprite("items/porkchop.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_COOKED_PORKCHOP, new SimpleSprite("items/cooked_porkchop.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_WOOL, new WoolItem());

        SPRITES_MAP.put(SPRITES.ITEM_MUTTON, new SimpleSprite("items/mutton.ans"));
        SPRITES_MAP.put(SPRITES.ITEM_COOKED_MUTTON, new SimpleSprite("items/cooked_mutton.ans"));

        SPRITES_MAP.put(SPRITES.HEART, new Heart());
        SPRITES_MAP.put(SPRITES.HUNGER, new Hunger());

        SPRITES_MAP.put(SPRITES.PIG, new Pig());
        SPRITES_MAP.put(SPRITES.SHEEP, new Sheep());
    }

    public static SpriteList<SPRITES> load() {
        return new SpriteList<>(SPRITES.class, SPRITES_MAP);
    }
}
